import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Bottle randomly falls from the sky at a random speed.
 * 
 * Receives the Catcher object which tracks the score, lives and rounds.
 * 
 * @author John Brink
 * @version March 2011
 */
public class Bottle  extends Actor
{
    int dropSpeed;
    int lives;
    
    Label lblLives;
    Catcher catcher;
    Color lblColor;
    
    public Bottle(int roundSpeed, Catcher pack)
    {
    dropSpeed = Greenfoot.getRandomNumber(roundSpeed) + 1;
      
      GreenfootImage img = getImage();
      img.scale(30,75);
      setImage(img);
      
      
      catcher = pack;
    
}

    /**
     * Act - A bottle just falls at a random speed.
     */
    public void act() 
    {
        fall(dropSpeed);
    }    
    
    public void fall(int speed)
    {
        int maxY = getWorld().getHeight() - 70;
        if (getY() + speed > maxY)
        {
            getWorld().removeObject(this);
            Greenfoot.playSound("bottlebreak.wav");
            lives = catcher.getLives();
            lives--;
            catcher.drawLives(lives);
            
            catcher.setLives(lives);
            
            
        } else {
        setLocation(getX(),getY()+speed);
    }
        
    }
}

