 

import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.lang.String;

/**
 * Write a description of class Catcher here.
 * 
 * @author John Brink 
 * @version March 2011
 */
public class Catcher  extends Actor
{
    
    int score = 0;
    int lives = 3;
    int round = 1;
    int roundProbability;
    int roundSpeed;
    Label lblScore;
    Label lblLives;
    Label lblRoundName;
    Label lblRoundNo;
    Color lblColor;
    Graphic imgLife1 = new Graphic();
    Graphic imgLife2 = new Graphic();
    Graphic imgLife3 = new Graphic();
    boolean first = true;
    
            
    public Catcher(Label label, Label label2)
    {
        lblScore = label;
        lblRoundName = label2;
        lblRoundNo = new Label("" + round);
        
        
        imgLife1.setImage("keg.png");
        imgLife2.setImage("keg.png");
        imgLife3.setImage("keg.png");
        
        
        // getWorld().addObject(lblScore,10,10);
        
        
    }
    /**
     * Act - do whatever the Catcher wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(first)
        {   
            getWorld().addObject(lblRoundNo, lblRoundName.getX(), lblRoundName.getY()+35);
            drawLives(lives);
            first = false;         
        }
        trackMouse();
        score += checkCatch();
        lblScore.setText("Score: " + score);
        
        dropBottle();
        checkLives();
    }  
    
    public void trackMouse()
    {
        if(Greenfoot.mouseMoved(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            int x = mouse.getX();
            int y  = this.getY();
            int minX = 75 + 75;
            int maxX = getWorld().getWidth() - 75;
            
            if (x < minX)
            {
                x = minX;
            } else if (x > maxX)
            {
                x = maxX;
            }
            
            setLocation(x, y);
        }
        
    }
    public int checkCatch()
    {
        Actor actor = getOneIntersectingObject(Bottle.class);
        if(actor != null)
        {
            // When a bottle is caught, remove bottle, update score and label
            getWorld().removeObject(actor);
            Greenfoot.playSound("clink.wav");
            return 100;
            
            
        } else
        return 0;
    }
    public boolean percentChance(int odds)
    {
        boolean chance = false;
        chance = (Greenfoot.getRandomNumber(100) < odds);
        return chance;
    }
    
    public void dropBottle()
    {
        // define a drop range for dropping bottles
        int minX = 75+75;
        int maxX = getWorld().getWidth() - 75;
        
        // Determine speed and frequency of bottles based on current round
        switch (round)
        {
            case  1:
            roundProbability = 10;
            roundSpeed = 4;
            if(score >= 2000)
            {
                round++;
                Greenfoot.playSound("roundup.wav");
            }
            break;
            case 2:
            roundProbability = 12;
            roundSpeed = 5;
            if(score >= 4000)
            {
                round++;
                Greenfoot.playSound("roundup.wav");
            }
            break;
            case 3:
            roundProbability = 14;
            roundSpeed = 6;
            if(score >=6000)
            {
                round++;
                Greenfoot.playSound("roundup.wav");
            }
            break;
            case 4:
            roundProbability = 16;
            roundSpeed = 7;
            if (score >= 8000)
                {
                round++;
                Greenfoot.playSound("roundup.wav");
            }
                break;
            default:
                int oldround = round;
                round = (int) (score/2000) + 1;
                if(round > oldround)
                    Greenfoot.playSound("roundup.wav");
                roundProbability = (round - 4) + 16;
                roundSpeed = (round - 4) + 7;
                break;
            
        }
        
        int x;
        int y = 1;
        // Get a random location within range
        x = Greenfoot.getRandomNumber(maxX - minX) + minX;
        lblRoundNo.setText("" + round);

        
        // create a new bottle at some random frequency
        if(percentChance(10))
        {
            if(percentChance(roundProbability))
            {
                getWorld().addObject(new Bottle(roundSpeed, this),x, y);
            }
        }
    }
    public void setLives(int lives)
    {
        this.lives = lives;
    }
    
    public int getLives()
    {
        return lives;
    }
    
    public void checkLives()
    {
        if (lives <= 0)
        {
            Graphic gameOver = new Graphic();
            gameOver.setImage("gameover.png");
           
            getWorld().removeObject(imgLife1);
     
            getWorld().addObject(gameOver, getWorld().getWidth()/2, getWorld().getHeight()/2);
            Greenfoot.stop();
            
        } 
    }
    
    public void drawLives(int livesRemaining)
    {
       // Draw images for number of lives
            int horizontal = 75;
            int vertical = getWorld().getHeight() - 75;
            
            switch (livesRemaining)
            {
                case 3:
                    if(first)
                    {
                        getWorld().addObject(imgLife1, horizontal, vertical);
                        vertical -= imgLife1.getImage().getHeight() + 10;
                        getWorld().addObject(imgLife2, horizontal, vertical);
                        vertical -= imgLife2.getImage().getHeight() + 10;
                        getWorld().addObject(imgLife3, horizontal, vertical);
                                                
                    } 
                    break;
                case 2:
                    getWorld().removeObject(imgLife3);
                    break;
                case 1:
                    getWorld().removeObject(imgLife2);
                    break;
                case 0:
                    getWorld().removeObject(imgLife1);
                    break;
                default:
                break;
            } // end switch
            
                      
    }
                   
            
            
    

}
